var GenericController = require( './generic' ),
    AuthorSchema = require( '../models/Author' );

function AuthorController () {
  GenericController.apply( this, arguments );
}
AuthorController.prototype.__proto__ = GenericController.prototype;

AuthorController.prototype._item_id = function ( req ) {
  return req.params.author;
};

AuthorController.prototype._validation_response = function ( res, err ) {
  var self = this,
      errors = err.errors,
      message = err.message,
      code = ( message && message.substring( 0, 6 ) );

  function unknown () {
    GenericController.prototype._validation_response.call( self, res, err );
  }

  if ( code.substring( 0, 1 ) === 'E' ) {
    if ( ( code === 'E11000' ) || ( code === 'E11001' ) ) {
      this._respond( res, null, 409, 'An author with that url already exists' );
    } else {
      unknown();
    }
  } else if ( errors ) {
    if ( errors.name && ( errors.name.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a name' );
    } else if ( errors.url && ( errors.url.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a URL' );
    } else {
      unknown();
    }
  } else {
    unknown();
  }
};

module.exports = AuthorController;

