var GenericController = require( './generic' ),
    PostSchema = require( '../models/Post' );

function PostController () {
  GenericController.apply( this, arguments );
}
PostController.prototype.__proto__ = GenericController.prototype;

PostController.prototype._item_id = function ( req ) {
  return req.params.post;
};

PostController.prototype._validation_response = function ( res, err ) {
  var self = this,
      errors = err.errors,
      message = err.message,
      code = ( message && message.substring( 0, 6 ) );

  function unknown () {
    GenericController.prototype._validation_response.call( self, res, err );
  }

  if ( errors ) {
    if ( errors.title && ( errors.title.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a title' );
    } else if ( errors.body && ( errors.body.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a body' );
    } else if ( errors.url && ( errors.url.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a url' );
    } else if ( errors.authors && ( errors.authors.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide at least one author' );
    } else {
      unknown();
    }
  } else {
    unknown();
  }
};

module.exports = PostController;

