var GenericController = require( './generic' ),
    TagSchema = require( '../models/Tag' );

function TagController () {
  GenericController.apply( this, arguments );
}
TagController.prototype.__proto__ = GenericController.prototype;

TagController.prototype._item_id = function ( req ) {
  return req.params.tag;
};

TagController.prototype._validation_response = function ( res, err ) {
  var self = this,
      errors = err.errors,
      message = err.message;

  function unknown () {
    GenericController.prototype._validation_response.call( self, res, err );
  }

  if ( errors ) {
    if ( errors.url && ( errors.url.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a url' );
    } else if ( errors.title && ( errors.title.type === 'required' ) ) {
      this._respond( res, null, 403, 'You must provide a title' );
    } else {
      unknown();
    }
  } else if ( message === 'Invalid ObjectId' ) {
    this._respond( res, null, 403, 'Invalid Blog ID' );
  } else {
    unknown();
  }
};

module.exports = TagController;

