var mongoose = require( 'mongoose' ),
    Schema = mongoose.Schema;

module.exports = function ( options ) {
  var Author = new Schema({
    name: {
      type: String,
      required: true,
      validate: function ( name ) {
        return name && ( name.length > 0 );
      }
    },
    url: {
      type: String,
      required: true,
      unique: true,
      validate: function ( url ) {
        return url && ( url.length > 0 );
      }
    }
  });

  Author.plugin( require( './plugins/modified' ) );

  options.mongo.model( 'Author', Author );

  return options.mongo.model( 'Author' );
};

