var mongoose = require( 'mongoose' ),
    Schema = mongoose.Schema,
    ObjectId = Schema.ObjectId;

module.exports = function ( options ) {
  var Post = new Schema({
    pubdate: Date,
    url: {
      type: String,
      required: true
    },
    title: {
      type: String,
      required: true
    },
    body: {
      type: String,
      required: true
    },
    authors: {
      type: [{
        type: ObjectId,
        ref: 'Author'
      }],
      required: true
    },
    tags: {
      type: [{
        type: ObjectId,
        ref: 'Tag'
      }]
    }
  });

  Post.plugin( require( './plugins/modified' ) );

  options.mongo.model( 'Post', Post );

  return options.mongo.model( 'Post' );
};

