var mongoose = require( 'mongoose' ),
    Schema = mongoose.Schema,
    ObjectId = Schema.ObjectId;

var crypto = require( 'crypto' );
function md5 ( str ) {
  var md5Hash = crypto.createHash( 'md5' );
  md5Hash.update( str );
  return md5Hash.digest( 'hex' );
}

module.exports = function ( options ) {
  var User = new Schema({
    name: {
      type: String,
      required: true,
      unique: true,
      validate: function ( name ) {
        return name && ( name.length > 0 );
      }
    },
    password: {
      type: String,
      required: true,
      validate: function ( password ) {
        return password && ( password.length > 0 );
      }
    },
    author: {
      type: ObjectId,
      ref: 'Author'
    },
    admin: {
      type: Boolean,
      required: true,
      default: false
    }
  });

  User.static( 'encrypt_pass', function ( v ) {
    return md5( v + options.salt );
  });

  User.path( 'password' ).set( function ( v ) {
    if ( v === '' ) {
      return v;
    } else {
      return User.statics.encrypt_pass( v );
    }
  });

  User.plugin( require( './plugins/modified' ) );

  options.mongo.model( 'User', User );

  return options.mongo.model( 'User' );
};

