module.exports = function ( schema ) {

  schema.add({
    created: {
      type: Date,
      index: true
    },
    updated: {
      type: Date,
      index: true
    }
  });

  schema.pre( 'save', function ( next ) {
    if ( this.isModified( 'created' ) ) {
      next( new Error( 'created lock' ) );
    } else if ( this.isModified( 'updated' ) ) {
      next( new Error( 'updated lock' ) );
    } else {
      var now = Date.now();

      if ( this.isNew ) {
        this.created = now;
      }

      this.updated = now;

      next();
    }
  });

};
