var vows = require( 'vows' ),
    assert = require( 'assert' ),
    lib = require( './lib' ),
    request = lib.request;

lib.setup( function ( conf ) {

vows.describe( 'Auth Tests' ).addBatch({

  'WHEN I make a request without authenticating': {
    topic: function () {
      request( null, { uri: '/auth' }, this.callback );
    },
    'THEN I should get a 401': function ( err, res, body ) {
      assert.equal( 401, res.statusCode );
    }
  },

  'WHEN I make a request with proper authentication': {
    topic: function () {
      request( [ conf.user, conf.password ], {
        uri: '/auth'
      }, this.callback );
    },
    'THEN I should get a 200': function ( err, res, body ) {
      assert.equal( 200, res.statusCode );
    },
    'THEN I should get my UID back': function ( err, res, body ) {
      body = JSON.parse( body );
      assert.equal( conf.user._id, body.uid );
    }
  },

  teardown: conf.teardown

}).export( module );

});
