var fs = require( 'fs' ),
    PATH = require( 'path' ),
    mongoose = require( 'mongoose' ),
    BlogSchema = require( '../models/Blog' ),
    UserSchema = require( '../models/User' );

var conf_file = PATH.resolve( process.argv[ 2 ] ),
    conf = JSON.parse( fs.readFileSync( conf_file, 'utf-8' ) );

var mongo = mongoose.createConnection( conf.mongo );

var Blog = BlogSchema( { mongo: mongo } ),
    User = UserSchema( { mongo: mongo, salt: conf.salt } );

function ask ( question, callback ) {
  var stdin = process.stdin,
      stdout = process.stdout;

  stdin.resume();
  stdout.write( question );

  stdin.once( 'data', function ( data ) {
    data = data.toString().trim();
    callback( data );
  });
}

ask( 'Blog title: ', function ( title ) {
ask( 'Blog user: ', function ( name ) {
ask( 'Blog password: ', function ( password ) {
ask( 'You sure? ', function ( sure ) {

  process.stdin.destroy();

  if ( sure.toLowerCase()[ 0 ] === 'y' ) {
    var blog = new Blog( { title: title } ),
        user = new User( { name: name, password: password } );

    blog.save( function ( err ) {
      if ( err ) {
        console.log( 'ERROR SAVING BLOG', err );
      } else {
        user.save( function ( err ) {
          mongo.close();
          if ( err ) {
            console.log( 'ERROR SAVING USER', err );
          } else {
            console.log( 'Done' );
            console.log( 'Blog ID: ' + blog._id );
          }
        });
      }
    });
  }

}); }); }) });
